<!--
  -    Copyright [2020] Feather development team, see AUTHORS.md
  -
  -    Licensed under the Apache License, Version 2.0 (the "License");
  -    you may not use this file except in compliance with the License.
  -    You may obtain a copy of the License at
  -
  -        http://www.apache.org/licenses/LICENSE-2.0
  -
  -    Unless required by applicable law or agreed to in writing, software
  -    distributed under the License is distributed on an "AS IS" BASIS,
  -    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  -    See the License for the specific language governing permissions and
  -    limitations under the License.
  -->

<template>
  <v-row v-if="!loading">
    <v-col md="4">
      <v-card>
        <v-container class="fill-height" fluid style="padding: 0">
          <v-row class="fill-height" style="margin: 0" v-if="sandboxDetails != null">
            <v-col md="auto" class="success">
              <v-avatar tile size="70">
                <v-icon x-large dark>mdi-cards-playing-outline</v-icon>
              </v-avatar>
            </v-col>
            <v-col class="white">
              <v-card flat>
                <v-card-title class="pa-0">{{ sandboxDetails.name }}</v-card-title>
                <v-card-text class="pa-0">
                  {{ sandboxDetails.packagesOpen }} offen /
                  {{ sandboxDetails.packagesClosed }} erledigt
                </v-card-text>
              </v-card>
            </v-col>
          </v-row>
          <v-row class="fill-height" style="margin: 0" v-else>
            <v-col md="auto" class="error">
              <v-avatar tile size="70">
                <v-icon x-large dark>mdi-cards-playing-outline</v-icon>
              </v-avatar>
            </v-col>
            <v-col class="white">
              <v-card flat>
                <v-card-title class="pa-0">No Sandbox</v-card-title>
                <v-card-text class="pa-0"> Noch keine Sandbox eingerichtet </v-card-text>
              </v-card>
            </v-col>
          </v-row>
        </v-container>
      </v-card>
    </v-col>
    <v-col md="4">
      <v-card>
        <v-container class="fill-height" fluid style="padding: 0">
          <v-row class="fill-height" style="margin: 0">
            <v-col md="auto" class="blue">
              <v-avatar tile size="70">
                <v-icon x-large dark>mdi-book-open-variant</v-icon>
              </v-avatar>
            </v-col>
            <v-col class="white">
              <v-card flat>
                <v-card-title class="pa-0">{{ templateDetails.name }}</v-card-title>
                <v-card-text class="pa-0">
                  {{ templateDetails.packagesOpen }} offen /
                  {{ templateDetails.packagesClosed }} erledigt
                </v-card-text>
              </v-card>
            </v-col>
          </v-row>
        </v-container>
      </v-card>
    </v-col>
    <v-col
      md="8"
      v-if="
        applicationStore.session.user.permissions.includes('RESET_SANDBOX') ||
        applicationStore.session.user.permissions.includes('ADMIN')
      "
    >
      <v-card>
        <v-card-title class="red--text"> Sandbox zurücksetzen </v-card-title>
        <v-card-text>
          <v-alert type="success" v-if="success"> Sandbox wurde zurückgesetzt. </v-alert>

          <v-form ref="form" v-if="!success">
            <v-alert type="warning" v-if="error">
              Bitte folgende Fehler beheben:
              <ul>
                <li v-for="e in error" :key="e">
                  {{ e }}
                </li>
              </ul>
            </v-alert>

            <div>
              <b>ACHTUNG!</b><br />
              Nach Zurücksetzen des Sandkastens müssen ein paar Aktionen manuell durchgeführt
              werden. Diese Schritte sind:
              <ul>
                <li>Übersichtsseite</li>
                <ul>
                  <li>
                    In der Projektbeschreibung die Verlinkung auf den Nextcloud-Ordner setzen. (<a
                      href="https://nextcloud.apps.ingenieure.cloud/f/12023"
                      >https://nextcloud.apps.ingenieure.cloud/f/12023</a
                    >)
                  </li>
                  <li>
                    Unter "Infos" (Kachel oben rechts) das Sandkasten-Bild und die Hinweise
                    ergänzen. Die Inhalte können von der Vorlage auf der
                    <a href="https://openproject.apps.ingenieure.cloud/projects/kg-it/"
                      >Übersichtsseite der KG IT</a
                    >
                    (ganz unten) kopiert und eingefügt werden.
                  </li>
                  <li>In dieser Info das Datum des Zurücksetzens eintragen.</li>
                </ul>
                <li>
                  Damit die
                  <a
                    href="https://openproject.apps.ingenieure.cloud/projects/kg-it/wiki/schnitzeljagd"
                    >Vegane Schnitzeljagd</a
                  >
                  funktioniert:
                </li>
                <ul>
                  <li>
                    Arbeitspaket entsprechend
                    <a href="https://openproject.apps.ingenieure.cloud/work_packages/8557">#8557</a>
                    anlegen
                  </li>
                  <ul>
                    <li>
                      Das Arbeitspaket kann vollständig kopiert und das Neue danach in das
                      Sandkasten-Projekt verschoben werden.
                    </li>
                    <li>Das Kommentar im Arbeitspaket muss danach ebenfalls eingefügt werden.</li>
                    <li>Arbeitspaket-ID des neuen Arbeitspaketes für den nächsten Punkt merken.</li>
                  </ul>
                  <li>
                    Besprechung nach dieser Vorlage anlegen:
                    <a href="https://openproject.apps.ingenieure.cloud/meetings/603"
                      >https://openproject.apps.ingenieure.cloud/meetings/603</a
                    >
                  </li>
                  <ul>
                    <li>Das Datum der Besprechung MUSS der 01.01.2021 sein.</li>
                    <li>der Agenda/Protokoll-Text muss kopiert und eingefügt werden.</li>
                    <li>
                      Im Agenda/Protokoll-Text wird auf ein Arbeitspaket verwiesen. Dort die Nummer
                      des eben angelegten Arbeitspaketes eintragen.
                    </li>
                  </ul>
                  <li>
                    Datei im Nextcloud-Ordner des Sandkastens überprüfen:
                    <a href="https://nextcloud.apps.ingenieure.cloud/f/12043"
                      >https://nextcloud.apps.ingenieure.cloud/f/12043</a
                    >
                  </li>
                  <ul>
                    <li>Die Datei "Hinweis zur Veganen Schitzeljagd.docx" muss dort liegen.</li>
                    <li>
                      Falls nicht, das Backup von
                      <a href="https://nextcloud.apps.ingenieure.cloud/f/219931">hier</a>
                      in den Sandkasten-Ordner kopieren.
                    </li>
                  </ul>
                </ul>
              </ul>
            </div>

            <v-checkbox
              v-model="resetSandbox.verified"
              :rules="[(v) => !!v || 'Die Zustimmung ist erforderlich']"
              :disabled="sending"
              required
            >
              <template v-slot:label>
                Die Sandbox soll zurückgesetzt werden (aktueller Inhalt wird überschrieben).
              </template>
            </v-checkbox>

            <background-job-status
              v-if="resetSandboxJobId"
              :job-id="resetSandboxJobId"
              @job_completed="processJobCompleted"
            >
            </background-job-status>
          </v-form>
        </v-card-text>
        <v-card-actions>
          <v-btn
            color="orange darken-2"
            class="pa-4 white--text"
            tile
            @click="reset"
            v-if="success"
          >
            Sandbox erneut zurücksetzen
          </v-btn>
          <v-spacer />
          <v-btn
            color="orange darken-2"
            class="pa-4 white--text"
            tile
            @click="doResetSandbox"
            :loading="sending"
            :disabled="sending"
            v-if="!success"
            >Sandbox zurücksetzen
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-col>
  </v-row>
  <v-row v-else>
    <v-col>
      <v-progress-circular indeterminate></v-progress-circular>
    </v-col>
  </v-row>
</template>

<script>
import * as api from '../../api';
import * as util from "../../util";
import Api from '../../LegacyApi';
import { useApplicationStore } from '../../stores/application';

export default {
  beforeUnmount() {
    this.$emit('clearError');
  },
  methods: {
    computeStats(details) {
      var packagesOpen = 0;
      var packagesClosed = 0;
      if (details.workPackageStats) {
        for (const [key, value] of Object.entries(details.workPackageStats)) {
          if (key === 'Closed') {
            packagesClosed += value;
          } else {
            packagesOpen += value;
          }
        }
      }
      return {
        id: details.project.id,
        name: details.project.name,
        packagesClosed,
        packagesOpen,
      };
    },
    initSandboxStatus() {
      Api.defaultHandler(this, Api.getSandboxStatus()).then((result) => {
        if (result.sandboxDetails) {
          this.sandboxDetails = this.computeStats(result.sandboxDetails);
        } else {
          this.sandboxDetails = null;
        }
        this.templateDetails = this.computeStats(result.templateDetails);
        this.loading = false;
      });
    },
    reset: function () {
      this.error = null;
      this.resetSandbox.verified = false;
      this.sending = false;
      this.success = false;
    },
    doResetSandbox: function () {
      if (this.$refs.form.validate()) {
        this.$emit('clearError');
        this.sending = true;

        const request = {
          verified: this.resetSandbox.verified,
        };

        fetch(util.CONFIG.API_BASE_URL + '/v1/bindings/iog/sandbox/reset?async=true', {
          method: 'POST',
          credentials: 'include',
          body: JSON.stringify(request),
        })
          .then((response) => {
            if (response.status === 200) {
              response.json().then((data) => {
                this.resetSandboxJobId = data.id;
              });
            } else if (response.status === 401) {
              this.$router.push('/logout');
            } else if (response.status === 400) {
              this.sending = false;
              response
                .json()
                .then((data) => {
                  this.error = data;
                })
                .catch((error) => {
                  console.log(error);
                  this.$emit('unexpectedError');
                });
            } else {
              this.sending = false;
              this.$emit('unexpectedError');
            }
          })
          .catch((error) => {
            console.log(error);
            this.sending = false;
            this.$emit('networkError');
          });
      }
    },
    processJobCompleted: function (result) {
      if (api.job.isErrorResult(result)) {
        this.error = [result.error];
        this.sending = false;
      } else {
        this.success = true;
        this.sending = false;
        this.initSandboxStatus();
      }
    },
  },
  mounted() {
    if (
      this.applicationStore.config.bindings.openproject &&
      this.applicationStore.config.bindings.openproject.enabled
    ) {
      this.initSandboxStatus();
    }
  },
  data: () => {
    return {
      loading: true,
      sandboxDetails: [],
      templateDetails: [],
      sending: false,
      resetSandboxJobId: null,
      success: false,
      error: null,
      resetSandbox: {
        verified: false,
      },
      applicationStore: useApplicationStore(),
      util,
    };
  },
};
</script>

<style scoped></style>
